# Documentation string. I wonder what ever refers to it? 

__doc__ = """Fortune Product

This module provides the harness for the Fortune class."""

# Version string. Usually updated automatically by 

from Globals import HTMLFile, MessageDialog, Persistent
import OFS.SimpleItem, Acquisition, AccessControl.Role, os, string, cgi

manage_addFortuneForm = HTMLFile('fortuneAdd', globals()) 

def manage_addFortune(self, id, title='', long=0, REQUEST=None):
    """Add a Fortune to a folder."""
    self._setObject(id, Fortune(id, title, long))
    if REQUEST is not None:
        return self.manage_main(self, REQUEST)

class Fortune(OFS.SimpleItem.Item, Persistent, Acquisition.Implicit,
              AccessControl.Role.RoleManager):
    """Fortune object."""
        
    meta_type = 'Fortune' # what do people think they're adding? 

    manage_options = ( # what management options are there?
	{'label': 'Edit',       'action': 'manage_main'},
	{'label': 'View',       'action': ''}, # defaults to index_html
	{'label': 'Security',   'action': 'manage_access'},
        ) 

    __ac_permissions__=( # what permissions make sense for us? 
	('View management screens', ('manage_tabs','manage_main')),
	('Change permissions',      ('manage_access',)           ),
	('Change Fortunes'     ,     ('manage_edit',)             ),
	('View Fortunes',            ('',)                        ),
	)

    def __init__(self, id, title='', long=0): 
        """initialise a new instance of Fortune"""
        self.id = id
        self.title = title
        self.long = long

    def index_html(self, REQUEST):
        '''run fortune and return the output'''
        REQUEST.RESPONSE.setHeader('content-type', 'text/html')
        return str(self)
 
    def __str__(self):
        if self.long:
            fp = os.popen("/usr/games/fortune -l")
        else:
            fp = os.popen("/usr/games/fortune")
        try:
            s = fp.read()
        finally:
            fp.close()
        return '<PRE>%s</PRE>' % cgi.escape(s)

    manage_main = HTMLFile('fortuneEdit', globals()) # Management Interface
    
    def manage_edit(self, title, long, REQUEST=None): 
        """does this really need a doc string?"""
        self.title = title
        self.long = long
	if REQUEST is not None:
	    return MessageDialog(
		title = 'Edited',
		message = "Properties for %s changed." % self.id,
		action = './manage_main',
		)
